diff --git a/test/unit/commands/setup/exit_code_test.rb b/test/unit/commands/setup/exit_code_test.rb
new file mode 100644
index 00000000..ab57a357
--- /dev/null
+++ b/test/unit/commands/setup/exit_code_test.rb
@@ -0,0 +1,24 @@
+require "test_helper"
+require "hive/cli"
+require "hive/commands/setup"
+
+class SetupExitCodeTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_cli_exits_nonzero_when_any_setup_phase_fails
+    fake = Class.new do
+      def initialize(**) = nil
+      def call = { "ok" => false }
+    end
+    original = Hive::Commands.const_get(:Setup)
+    Hive::Commands.send(:remove_const, :Setup)
+    Hive::Commands.const_set(:Setup, fake)
+
+    _out, _err, status = with_captured_exit { Hive::CLI.start([ "setup" ]) }
+
+    assert_equal 1, status
+  ensure
+    Hive::Commands.send(:remove_const, :Setup)
+    Hive::Commands.const_set(:Setup, original)
+  end
+end
diff --git a/test/unit/commands/setup/orchestrator_test.rb b/test/unit/commands/setup/orchestrator_test.rb
new file mode 100644
index 00000000..181210e4
--- /dev/null
+++ b/test/unit/commands/setup/orchestrator_test.rb
@@ -0,0 +1,137 @@
+require "test_helper"
+require "hive/commands/setup"
+require "hive/commands/service_installer/outcome"
+
+class SetupOrchestratorTest < Minitest::Test
+  include HiveTestHelper
+
+  Check = Struct.new(:name, :status, :bootstrappable, keyword_init: true) do
+    def success? = status == "pass"
+    def to_h
+      {
+        "name" => name, "category" => "test", "detected" => nil,
+        "required" => nil, "status" => status, "remediation" => [],
+        "bootstrappable" => bootstrappable, "message" => nil
+      }
+    end
+  end
+
+  def test_runs_phases_in_order_and_shares_one_binary
+    calls = []
+    diagnostics = Object.new
+    diagnostics.define_singleton_method(:call) do
+      calls << :diagnostics
+      [ Check.new(name: "qmd", status: "missing", bootstrappable: true) ]
+    end
+    setup = Hive::Commands::Setup.new(
+      diagnostics: diagnostics,
+      qmd_bootstrap: -> { calls << :qmd; true },
+      bundle_installer: -> { calls << :bundle; true },
+      daemon_installer: ->(binary) { calls << [ :daemon, binary ]; true },
+      daemon_status: ->(binary) { calls << [ :daemon_status, binary ]; { "ready" => true } },
+      enroller: -> { calls << :enroll; true },
+      web_installer: ->(binary) { calls << [ :web, binary ]; true },
+      web_status: -> { calls << :web_status; { "ready" => true, "url" => "http://127.0.0.1:4567" } },
+      binary: "/opt/hive/bin/hive"
+    )
+
+    result = setup.call
+
+    assert result.fetch("ok")
+    assert_equal(
+      [
+        :diagnostics, :qmd, :bundle, [ :daemon, "/opt/hive/bin/hive" ],
+        [ :daemon_status, "/opt/hive/bin/hive" ], :enroll,
+        [ :web, "/opt/hive/bin/hive" ], :web_status
+      ],
+      calls
+    )
+  end
+
+  def test_mandatory_failure_prevents_mutation
+    calls = []
+    diagnostics = Object.new
+    diagnostics.define_singleton_method(:call) do
+      [ Check.new(name: "ruby", status: "fail", bootstrappable: false) ]
+    end
+    setup = Hive::Commands::Setup.new(
+      diagnostics: diagnostics,
+      qmd_bootstrap: -> { calls << :mutation },
+      bundle_installer: -> { calls << :mutation },
+      daemon_installer: ->(*) { calls << :mutation },
+      daemon_status: ->(*) { calls << :mutation },
+      enroller: -> { calls << :mutation },
+      web_installer: ->(*) { calls << :mutation },
+      web_status: -> { calls << :mutation }
+    )
+
+    result = setup.call
+
+    refute result.fetch("ok")
+    assert_empty calls
+    assert_equal "diagnostics", result.fetch("phases").last.fetch("name")
+  end
+
+  def test_no_service_prints_foreground_next_step_without_web_mutation
+    diagnostics = Object.new
+    diagnostics.define_singleton_method(:call) { [] }
+    output = StringIO.new
+    setup = Hive::Commands::Setup.new(
+      diagnostics: diagnostics, no_service: true, output: output,
+      bundle_installer: -> { true },
+      daemon_installer: ->(*) { true },
+      daemon_status: ->(*) { { "ready" => true } },
+      enroller: -> { true },
+      web_installer: ->(*) { raise "must not install web service" },
+      web_status: -> { raise "must not probe web service" }
+    )
+
+    result = setup.call
+
+    assert result.fetch("ok")
+    assert_match(/hive web/, output.string)
+  end
+
+  def test_service_manager_fallback_finishes_prerequisites_and_reports_exact_command
+    diagnostics = Object.new
+    diagnostics.define_singleton_method(:call) { [] }
+    calls = []
+    output = StringIO.new
+    setup = Hive::Commands::Setup.new(
+      diagnostics: diagnostics,
+      output: output,
+      bundle_installer: -> { calls << :bundle; true },
+      daemon_installer: ->(*) {
+        calls << :daemon
+        Hive::Commands::ServiceInstaller::Outcome.new(:autostart_unavailable)
+      },
+      daemon_status: ->(*) { raise "must not probe an unavailable manager" },
+      enroller: -> { calls << :enroll; true },
+      web_installer: ->(*) { raise "must not install a second managed service" },
+      web_status: -> { raise "must not probe an unavailable service" }
+    )
+
+    result = setup.call
+
+    refute result.fetch("ok")
+    assert_equal %i[bundle daemon enroll], calls
+    assert_includes output.string, "hive daemon start --detach && hive web"
+    fallback = result.fetch("phases").find { |phase| phase["name"] == "web_service" }
+    assert_includes fallback.fetch("remediation").join(" "), "hive daemon start --detach && hive web"
+  end
+
+  def test_failed_phase_always_has_actionable_remediation
+    diagnostics = Object.new
+    diagnostics.define_singleton_method(:call) { [] }
+    setup = Hive::Commands::Setup.new(
+      diagnostics: diagnostics,
+      bundle_installer: -> { false }
+    )
+
+    result = setup.call
+    failure = result.fetch("phases").find { |phase| !phase["ok"] }
+
+    refute_empty failure.fetch("remediation")
+    assert_match(/hive web install/, failure.fetch("remediation").join(" "))
+  end
+end
diff --git a/test/unit/commands/uninstall_test.rb b/test/unit/commands/uninstall_test.rb
index 8d1e6be5..b2083bb3 100644
--- a/test/unit/commands/uninstall_test.rb
+++ b/test/unit/commands/uninstall_test.rb
@@ -65,7 +65,7 @@ class UninstallCommandTest < Minitest::Test
       File.write(plist, "plist\n")
       out = StringIO.new
 
-      Hive::Commands::Uninstall.new(
+      result = Hive::Commands::Uninstall.new(
         purge: true,
         output: out,
         runner: ->(_argv) { false },
@@ -93,6 +93,56 @@ class UninstallCommandTest < Minitest::Test
     end
   end
 
+  def test_web_runtime_removal_preserves_storage_without_explicit_state_purge
+    with_xdg_home do
+      [ Hive::Paths.web_app_home, Hive::Paths.web_gems_home, Hive::Paths.web_storage_home ].each do |path|
+        FileUtils.mkdir_p(path)
+      end
+
+      Hive::Commands::Uninstall.new(output: StringIO.new).send(:remove_web_runtime)
+
+      refute File.exist?(Hive::Paths.web_app_home)
+      refute File.exist?(Hive::Paths.web_gems_home)
+      assert File.exist?(Hive::Paths.web_storage_home)
+    end
+  end
+
+  def test_web_storage_is_removed_only_with_explicit_state_purge
+    with_xdg_home do
+      FileUtils.mkdir_p(Hive::Paths.web_storage_home)
+
+      Hive::Commands::Uninstall.new(
+        force_purge_state: true, output: StringIO.new
+      ).send(:remove_web_runtime)
+
+      refute File.exist?(Hive::Paths.web_storage_home)
+    end
+  end
+
+  def test_web_runtime_is_preserved_when_service_deregistration_fails
+    with_xdg_home do
+      unit = File.expand_path("~/.config/systemd/user/hive-web.service")
+      FileUtils.mkdir_p(File.dirname(unit))
+      File.write(unit, "unit\n")
+      FileUtils.mkdir_p(Hive::Paths.web_app_home)
+      File.write(File.join(Hive::Paths.web_app_home, "keep"), "active service dependency\n")
+      output = StringIO.new
+
+      result = Hive::Commands::Uninstall.new(
+        purge: true,
+        output: output,
+        runner: ->(argv) { argv.include?("hive-web") ? false : true },
+        host_os: "linux"
+      ).call
+
+      assert File.exist?(unit)
+      assert File.exist?(File.join(Hive::Paths.web_app_home, "keep"))
+      assert_match(/preserving the web runtime/, output.string)
+      assert_equal 1, result
+      refute_match(/cleanup complete/, output.string)
+    end
+  end
+
   def test_remove_user_symlinks_removes_hive_and_hv_links
     with_xdg_home do
       bin = Hive::Paths.bin_home
diff --git a/test/unit/commands/web/service_installer_test.rb b/test/unit/commands/web/service_installer_test.rb
new file mode 100644
index 00000000..dba38e71
--- /dev/null
+++ b/test/unit/commands/web/service_installer_test.rb
@@ -0,0 +1,66 @@
+require "test_helper"
+require "hive/commands/web/service_installer"
+
+class WebServiceInstallerTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_systemd_unit_uses_exact_binary_and_xdg_paths
+    with_xdg_home do |dir|
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "linux", home: File.join(dir, "home"),
+        binary_path: "/opt/Hive Bin/hive", systemctl_available: false
+      )
+
+      body = installer.send(:render_systemd)
+
+      assert_includes body, "ExecStart=/opt/Hive\\ Bin/hive web"
+      assert_includes body, "HIVE_WEB_BIND=127.0.0.1"
+      assert_includes body, "HIVE_INVOKED_BIN=/opt/Hive Bin/hive"
+      assert_includes body, Hive::Paths.web_gems_home
+      assert_includes body, "StartLimitBurst=3"
+      assert_equal 1, body.scan(/^Environment=PATH=/).length
+      refute_includes body, "ExecStart=hive-daemon"
+    end
+  end
+
+  def test_launchd_plist_is_xml_safe
+    with_tmp_dir do |dir|
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "darwin", home: dir, binary_path: "/tmp/hive&tools/hive",
+        launchctl_available: false
+      )
+
+      body = installer.send(:render_launchd)
+
+      assert_includes body, "/tmp/hive&amp;tools/hive"
+      assert_includes body, "<string>local.hive-web</string>"
+      assert_includes body, "<string>web</string>"
+      assert_includes body, '[ -x "$0" ] || exit 0'
+      assert_includes body, "<key>PATH</key>"
+      assert_includes body, "/opt/homebrew/bin"
+    end
+  end
+
+  def test_selected_bind_port_and_unsafe_mode_are_rendered_and_rediscovered
+    with_xdg_home do |dir|
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "linux",
+        home: File.join(dir, "home"),
+        binary_path: "/opt/hive",
+        bind: "0.0.0.0",
+        port: 5678,
+        unsafe: true,
+        systemctl_available: false
+      )
+
+      installer.install!(autostart: false)
+      settings = installer.installed_settings
+
+      assert_equal "0.0.0.0", settings.fetch("bind")
+      assert_equal 5678, settings.fetch("port")
+      assert_equal true, settings.fetch("unsafe")
+      assert_equal "http://0.0.0.0:5678", settings.fetch("url")
+      assert_equal false, settings.fetch("configuration_drift")
+    end
+  end
+end
diff --git a/test/unit/current_main_coverage_gap_test.rb b/test/unit/current_main_coverage_gap_test.rb
index 1c17f2a6..31b7fae6 100644
--- a/test/unit/current_main_coverage_gap_test.rb
+++ b/test/unit/current_main_coverage_gap_test.rb
@@ -89,6 +89,16 @@ class CurrentMainCoverageGapTest < Minitest::Test
     Hive::Stages::Review::AcceptedFindings.new(text: text, count: count)
   end
 
+  def with_auto_commit_capture3_stub(replacement)
+    open3_stub = ->(*argv, **_kwargs) { replacement.call(*argv) }
+    bounded_stub = ->(*argv, **_kwargs) { replacement.call(*argv) }
+    with_replaced_singleton_method(Open3, :capture3, open3_stub) do
+      with_replaced_singleton_method(Hive::BoundedProcess, :capture3, bounded_stub) do
+        yield
+      end
+    end
+  end
+
   def with_fake_profile(profile = FakeProfile.new(:codex))
     with_replaced_singleton_method(Hive::AgentProfiles, :lookup, ->(*_args, **_kwargs) { profile }) do
       yield profile
@@ -439,7 +449,7 @@ class CurrentMainCoverageGapTest < Minitest::Test
       fail_status = ReviewCommandStatus.new(false)
       ok_status = ReviewCommandStatus.new(true)
 
-      with_replaced_singleton_method(Open3, :capture3, ->(*_argv) { [ "", "", fail_status ] }) do
+      with_auto_commit_capture3_stub(->(*_argv) { [ "", "", fail_status ] }) do
         result = Hive::Stages::Review.send(:auto_commit_fix_worktree, task, cfg, ctx, accepted_findings)
 
         refute result[:success]
@@ -452,7 +462,7 @@ class CurrentMainCoverageGapTest < Minitest::Test
         [ "test/fix_test.rb\0", "", ok_status ],
         [ "", "", ok_status ]
       ]
-      with_replaced_singleton_method(Open3, :capture3, ->(*_argv) { responses.shift }) do
+      with_auto_commit_capture3_stub(->(*_argv) { responses.shift }) do
         with_replaced_singleton_method(Hive::Stages::Review, :auto_commit_git_commit, lambda { |_worktree, _policy, _message|
           { success: false, message: "git commit failed: stderr detail\nstdout detail" }
         }) do
@@ -484,7 +494,7 @@ class CurrentMainCoverageGapTest < Minitest::Test
         [ "test/fix_test.rb\0", "", ok_status ],
         [ "", "", ok_status ]
       ]
-      with_replaced_singleton_method(Open3, :capture3, ->(*argv) {
+      with_auto_commit_capture3_stub(->(*argv) {
         captured_argv << argv
         responses.shift
       }) do
@@ -520,7 +530,7 @@ class CurrentMainCoverageGapTest < Minitest::Test
         [ "test/fix_test.rb\0", "", ok_status ],
         [ "", "reset boom", fail_status ]
       ]
-      with_replaced_singleton_method(Open3, :capture3, ->(*_argv) { responses.shift }) do
+      with_auto_commit_capture3_stub(->(*_argv) { responses.shift }) do
         with_replaced_singleton_method(Hive::Stages::Review, :auto_commit_git_commit, lambda { |_worktree, _policy, _message|
           { success: false, message: "git commit failed: commit boom" }
         }) do
@@ -566,7 +576,7 @@ class CurrentMainCoverageGapTest < Minitest::Test
         [ "", "", ok_status ]
       ]
 
-      with_replaced_singleton_method(Open3, :capture3, ->(*argv) {
+      with_auto_commit_capture3_stub(->(*argv) {
         captured_argv << argv
         responses.shift
       }) do
@@ -602,7 +612,7 @@ class CurrentMainCoverageGapTest < Minitest::Test
         [ "", "", ok_status ]
       ]
 
-      with_replaced_singleton_method(Open3, :capture3, ->(*_argv) { responses.shift }) do
+      with_auto_commit_capture3_stub(->(*_argv) { responses.shift }) do
         result = Hive::Stages::Review.send(:auto_commit_fix_worktree, task, cfg, ctx, accepted_findings)
 
         refute result[:success]
@@ -636,7 +646,7 @@ class CurrentMainCoverageGapTest < Minitest::Test
 
       with_replaced_singleton_method(Hive::Stages::Review, :git_head, ->(_path) { "head-after" }) do
         with_replaced_singleton_method(Hive::Stages::Review, :auto_commit_git_commit, ->(_worktree, _policy, _message) { { success: true } }) do
-          with_replaced_singleton_method(Open3, :capture3, ->(*argv) {
+          with_auto_commit_capture3_stub(->(*argv) {
             captured_argv << argv
             responses.shift
           }) do
@@ -674,7 +684,7 @@ class CurrentMainCoverageGapTest < Minitest::Test
         commit_calls << [ commit_worktree, policy, message ]
         { success: true }
       }) do
-        with_replaced_singleton_method(Open3, :capture3, ->(*argv) {
+        with_auto_commit_capture3_stub(->(*argv) {
           captured_argv << argv
           responses.shift
         }) do
@@ -716,7 +726,7 @@ class CurrentMainCoverageGapTest < Minitest::Test
         commit_calls << [ commit_worktree, policy, message ]
         { success: true }
       }) do
-        with_replaced_singleton_method(Open3, :capture3, ->(*argv) {
+        with_auto_commit_capture3_stub(->(*argv) {
           captured_argv << argv
           responses.shift
         }) do
@@ -908,7 +918,7 @@ class CurrentMainCoverageGapTest < Minitest::Test
       ok_status = ReviewCommandStatus.new(true)
       captured_argv = []
 
-      with_replaced_singleton_method(Open3, :capture3, ->(*argv) {
+      with_auto_commit_capture3_stub(->(*argv) {
         captured_argv << argv
         [ "true\n", "", ok_status ]
       }) do
@@ -938,7 +948,7 @@ class CurrentMainCoverageGapTest < Minitest::Test
 
       fail_status = ReviewCommandStatus.new(false)
 
-      with_replaced_singleton_method(Open3, :capture3, ->(*_argv) { [ "", "fatal: bad config", fail_status ] }) do
+      with_auto_commit_capture3_stub(->(*_argv) { [ "", "fatal: bad config", fail_status ] }) do
         result = Hive::Stages::Review.send(:auto_commit_fix_worktree, task, cfg, ctx, accepted_findings)
 
         refute result[:success]
diff --git a/test/unit/daemon/status_report_test.rb b/test/unit/daemon/status_report_test.rb
new file mode 100644
index 00000000..40ab411b
--- /dev/null
+++ b/test/unit/daemon/status_report_test.rb
@@ -0,0 +1,61 @@
+require "test_helper"
+require "hive/daemon/status_report"
+
+class DaemonStatusReportTest < Minitest::Test
+  include HiveTestHelper
+
+  class Installer
+    attr_reader :path
+
+    def initialize(path)
+      @path = path
+    end
+
+    def service_state
+      {
+        "platform" => "linux", "unit_path" => path,
+        "service_installed" => true, "service_enabled" => true
+      }
+    end
+  end
+
+  class Probe
+    def read_live_pid = nil
+  end
+
+  def test_reports_path_drift_from_systemd_execstart
+    with_tmp_dir do |dir|
+      unit = File.join(dir, "hive-daemon.service")
+      File.write(unit, "[Service]\nExecStart=/old/bin/hive daemon start\n")
+      report = Hive::Daemon::StatusReport.new(
+        installer: Installer.new(unit), pid_probe: Probe.new,
+        pid_file: File.join(dir, "pid"), log_file: File.join(dir, "log"),
+        current_binary: "/new/bin/hive", current_version: Hive::VERSION,
+        runner: ->(_argv, timeout:) {
+          { ok: true, stdout: "hive #{Hive::VERSION}\n", stderr: "", exit_code: 0 }
+        }
+      ).to_h
+
+      assert_equal "/old/bin/hive", report.fetch("installed_executable")
+      assert_equal "path", report.fetch("drift")
+      assert_includes report.fetch("drift_message"), "/old/bin/hive"
+      assert_includes report.fetch("drift_message"), "/new/bin/hive"
+      refute report.fetch("ready")
+    end
+  end
+
+  def test_unparseable_installed_unit_is_unhealthy
+    with_tmp_dir do |dir|
+      unit = File.join(dir, "hive-daemon.service")
+      File.write(unit, "[Service]\nExecStart=/bin/sh -c 'echo nope'\n")
+      report = Hive::Daemon::StatusReport.new(
+        installer: Installer.new(unit), pid_probe: Probe.new,
+        pid_file: File.join(dir, "pid"), log_file: File.join(dir, "log"),
+        current_binary: "/bin/hive", current_version: Hive::VERSION
+      ).to_h
+
+      assert_equal "unparseable", report.fetch("drift")
+      refute report.fetch("ready")
+    end
+  end
+end
diff --git a/test/unit/gemspec_test.rb b/test/unit/gemspec_test.rb
index a4ddfc6e..d1ae8ff7 100644
--- a/test/unit/gemspec_test.rb
+++ b/test/unit/gemspec_test.rb
@@ -25,9 +25,14 @@ class GemspecTest < Minitest::Test
     assert_includes spec.files, "bin/hv"
   end
 
-  # The web tier is a Rails app under web/, supported only in the Docker
-  # image or a source checkout — the gem must stay a lean CLI and not
-  # package the app or its old Sinatra-era assets.
+  def test_gem_package_includes_gemspec_for_managed_web_path_resolution
+    spec = Gem::Specification.load(GEMSPEC_PATH)
+
+    assert_includes spec.files, "hive.gemspec"
+  end
+
+  # The Rails tree ships as a separate version-matched release bundle. The gem
+  # keeps only the small resolver/installer and its gemspec path entry.
   def test_gem_package_excludes_the_rails_web_app
     spec = Gem::Specification.load(GEMSPEC_PATH)
 
diff --git a/test/unit/release_contract_test.rb b/test/unit/release_contract_test.rb
new file mode 100644
index 00000000..4745be90
--- /dev/null
+++ b/test/unit/release_contract_test.rb
@@ -0,0 +1,12 @@
+require "test_helper"
+
+class ReleaseContractTest < Minitest::Test
+  def test_release_builds_and_signs_the_versioned_web_bundle
+    workflow = File.read(File.expand_path("../../.github/workflows/release.yml", __dir__))
+
+    assert_includes workflow, "hive-web-${version}.tar.gz"
+    assert_includes workflow, "name: hive-web-bundle"
+    assert_includes workflow, "sha256sum hive-cli-*.gem hive-web-*.tar.gz"
+    assert_includes workflow, "cosign sign-blob"
+  end
+end
diff --git a/test/unit/schema_files_test.rb b/test/unit/schema_files_test.rb
index 2d10237d..baeed474 100644
--- a/test/unit/schema_files_test.rb
+++ b/test/unit/schema_files_test.rb
@@ -1474,8 +1474,10 @@ class SchemaFilesTest < Minitest::Test
     # service_* fields are always emitted (null on probe failure), so they
     # are required-but-nullable in the schema.
     producer_required = %w[
-      schema schema_version ok running pid uptime_sec pid_file log_file
-      service_installed service_enabled unit_path current_version update_nudge
+      schema schema_version ok running pid uptime_sec pid_file log_file platform
+      service_installed service_enabled unit_path installed_executable
+      installed_version current_executable current_version drift drift_message
+      last_maintenance ready update_nudge
     ].sort
     assert_equal producer_required, schema_required,
                  "schema/producer required-key drift in hive-daemon-status.v1.json"
diff --git a/test/unit/setup/check_result_test.rb b/test/unit/setup/check_result_test.rb
new file mode 100644
index 00000000..0eb12608
--- /dev/null
+++ b/test/unit/setup/check_result_test.rb
@@ -0,0 +1,42 @@
+require "test_helper"
+require "hive/setup/check_result"
+
+class SetupCheckResultTest < Minitest::Test
+  def test_serializes_the_setup_contract
+    result = Hive::Setup::CheckResult.new(
+      name: "ruby",
+      category: "runtime",
+      detected: "3.4.7",
+      required: ">= 3.4",
+      status: "pass",
+      remediation: [],
+      bootstrappable: false
+    )
+
+    assert result.success?
+    assert_equal(
+      {
+        "name" => "ruby",
+        "category" => "runtime",
+        "detected" => "3.4.7",
+        "required" => ">= 3.4",
+        "status" => "pass",
+        "remediation" => [],
+        "bootstrappable" => false,
+        "message" => nil
+      },
+      result.to_h
+    )
+  end
+
+  def test_rejects_unknown_status
+    error = assert_raises(ArgumentError) do
+      Hive::Setup::CheckResult.new(
+        name: "ruby", category: "runtime", detected: nil, required: nil,
+        status: "maybe", remediation: [], bootstrappable: false
+      )
+    end
+
+    assert_match(/status/, error.message)
+  end
+end
diff --git a/test/unit/setup/diagnostics_test.rb b/test/unit/setup/diagnostics_test.rb
new file mode 100644
index 00000000..164a4f9d
--- /dev/null
+++ b/test/unit/setup/diagnostics_test.rb
@@ -0,0 +1,123 @@
+require "test_helper"
+require "hive/setup/diagnostics"
+
+class SetupDiagnosticsTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_old_ruby_and_missing_external_tool_fail_with_remediation
+    runner = ->(argv, timeout:) do
+      case argv
+      when [ "gh", "auth", "status" ] then { ok: true, stdout: "", stderr: "", exit_code: 0 }
+      when [ "claude", "auth", "status" ] then { ok: true, stdout: "", stderr: "", exit_code: 0 }
+      when [ "codex", "login", "status" ] then { ok: true, stdout: "", stderr: "", exit_code: 0 }
+      else { ok: true, stdout: "1.0", stderr: "", exit_code: 0 }
+      end
+    end
+    present = %w[git tmux node npm qmd sqlite3 cosign gh claude codex].to_h { |name| [ name, "/bin/#{name}" ] }
+    present.delete("sqlite3")
+
+    results = Hive::Setup::Diagnostics.new(
+      host_os: "linux", ruby_version: "3.3.9", runner: runner,
+      which: ->(name) { present[name] }, web_bundle_current: -> { true }
+    ).call
+
+    ruby = results.find { |row| row.name == "ruby" }
+    sqlite = results.find { |row| row.name == "sqlite3" }
+    refute ruby.success?
+    assert_equal ">= 3.4", ruby.required
+    assert_match(/Ruby 3.4/, ruby.remediation.join(" "))
+    refute sqlite.success?
+    assert_match(/sqlite3/, sqlite.remediation.join(" "))
+  end
+
+  def test_missing_hive_owned_dependencies_are_bootstrappable
+    present = %w[git tmux node npm sqlite3 cosign gh claude codex].to_h { |name| [ name, "/bin/#{name}" ] }
+    runner = ->(_argv, timeout:) { { ok: true, stdout: "ok", stderr: "", exit_code: 0 } }
+
+    results = Hive::Setup::Diagnostics.new(
+      host_os: "darwin", ruby_version: "3.4.1", runner: runner,
+      which: ->(name) { present[name] }, web_bundle_current: -> { false }
+    ).call
+
+    qmd = results.find { |row| row.name == "qmd" }
+    web = results.find { |row| row.name == "web_bundle" }
+    assert qmd.bootstrappable
+    assert web.bootstrappable
+    assert_equal "missing", qmd.status
+    assert_equal "missing", web.status
+  end
+
+  def test_authentication_failure_is_distinct_from_missing_command
+    present = %w[git tmux node npm qmd sqlite3 cosign gh claude codex].to_h { |name| [ name, "/bin/#{name}" ] }
+    runner = ->(argv, timeout:) do
+      if argv == [ "gh", "auth", "status" ]
+        { ok: false, stdout: "", stderr: "not logged in", exit_code: 1 }
+      else
+        { ok: true, stdout: "ok", stderr: "", exit_code: 0 }
+      end
+    end
+
+    results = Hive::Setup::Diagnostics.new(
+      host_os: "linux", ruby_version: "3.4.1", runner: runner,
+      which: ->(name) { present[name] }, web_bundle_current: -> { true }
+    ).call
+
+    gh = results.find { |row| row.name == "gh_auth" }
+    assert_equal "fail", gh.status
+    assert_match(/gh auth login/, gh.remediation.join(" "))
+    assert_equal "not logged in", gh.message
+  end
+
+  def test_unsupported_windows_fails_without_running_probes
+    calls = []
+    results = Hive::Setup::Diagnostics.new(
+      host_os: "mingw32", ruby_version: "3.4.1",
+      runner: ->(argv, timeout:) { calls << argv; raise "must not run" },
+      which: ->(_name) { "/bin/tool" }, web_bundle_current: -> { true }
+    ).call
+
+    assert_empty calls
+    platform = results.first
+    assert_equal "platform", platform.name
+    assert_equal "fail", platform.status
+    assert_match(/Linux or macOS/, platform.remediation.join(" "))
+  end
+
+  def test_managed_qmd_is_rediscovered_when_its_bin_directory_is_not_on_path
+    with_xdg_home do
+      managed = File.join(Hive::Paths.data_home, "qmd", "bin", "qmd")
+      FileUtils.mkdir_p(File.dirname(managed))
+      File.write(managed, "#!/bin/sh\n")
+      FileUtils.chmod(0o755, managed)
+      diagnostics = Hive::Setup::Diagnostics.new(
+        host_os: "linux",
+        ruby_version: "3.4.1",
+        web_bundle_current: -> { true }
+      )
+
+      with_env("PATH" => "") do
+        assert_equal managed, diagnostics.send(:which, "qmd")
+      end
+    end
+  end
+
+  def test_custom_bundle_sha_does_not_require_cosign
+    with_env(
+      "HIVE_WEB_BUNDLE_URL" => "https://packages.example.invalid/web.tgz",
+      "HIVE_WEB_BUNDLE_SHA256" => "a" * 64
+    ) do
+      diagnostics = Hive::Setup::Diagnostics.new(
+        host_os: "linux",
+        ruby_version: "3.4.1",
+        which: ->(_name) { "/bin/tool" },
+        runner: ->(_argv, timeout:) { { ok: true, stdout: "ok", stderr: "", exit_code: 0 } },
+        web_bundle_current: -> { false }
+      )
+
+      cosign = diagnostics.call.find { |result| result.name == "cosign" }
+
+      assert cosign.success?
+      assert_match(/custom SHA-256/, cosign.detected)
+    end
+  end
+end
diff --git a/test/unit/skill_check_test.rb b/test/unit/skill_check_test.rb
index f9b15b51..7d5ead39 100644
--- a/test/unit/skill_check_test.rb
+++ b/test/unit/skill_check_test.rb
@@ -481,7 +481,7 @@ class HiveSkillCheckPiTest < Minitest::Test
   end
 
   def test_global_npm_root_returns_nil_on_timeout
-    with_replaced_singleton_method(Timeout, :timeout, ->(_seconds) { raise Timeout::Error }) do
+    with_replaced_singleton_method(Hive::BoundedProcess, :capture3, ->(*_argv, **_kwargs) { raise Timeout::Error }) do
       assert_nil Hive::SkillCheck::Pi.global_npm_root
     end
   end
@@ -491,7 +491,7 @@ class HiveSkillCheckPiTest < Minitest::Test
     status.define_singleton_method(:success?) { true }
     captured_cmd = nil
 
-    with_replaced_singleton_method(Open3, :capture3, lambda { |*cmd|
+    with_replaced_singleton_method(Hive::BoundedProcess, :capture3, lambda { |*cmd, **_kwargs|
       captured_cmd = cmd
       [ "  /tmp/npm-root\nignored\n", "", status ]
     }) do
diff --git a/test/unit/stages/clean_exit_test.rb b/test/unit/stages/clean_exit_test.rb
index 06f5ec1e..5d04b73e 100644
--- a/test/unit/stages/clean_exit_test.rb
+++ b/test/unit/stages/clean_exit_test.rb
@@ -250,7 +250,7 @@ class HiveStagesCleanExitTest < Minitest::Test
     with_tmp_dir do |worktree|
       init_git(worktree)
 
-      result = with_open3_capture3_stub(
+      result = with_bounded_capture3_stub(
         ->(argv) { argv.include?("status") }
       ) do
         Hive::Stages::CleanExit.run!(
@@ -270,7 +270,7 @@ class HiveStagesCleanExitTest < Minitest::Test
       init_git(worktree)
       File.write(File.join(worktree, "lib.rb"), "x\n")
 
-      result = with_open3_capture3_stub(
+      result = with_bounded_capture3_stub(
         ->(argv) { argv.include?("add") && argv.include?("-A") }
       ) do
         Hive::Stages::CleanExit.run!(
@@ -309,20 +309,20 @@ class HiveStagesCleanExitTest < Minitest::Test
     YAML.unsafe_load(YAML.dump(Hive::Config::DEFAULTS))
   end
 
-  # Replace `Open3.capture3` with a stub that raises `Timeout::Error`
+  # Replace `BoundedProcess.capture3` with a stub that raises `Timeout::Error`
   # whenever `predicate.call(argv)` returns truthy; otherwise delegates
   # to the real implementation. Restores the original method on exit
   # even when the block raises.
-  def with_open3_capture3_stub(predicate)
-    original = Open3.method(:capture3)
-    Open3.singleton_class.send(:define_method, :capture3) do |*argv, **kwargs|
+  def with_bounded_capture3_stub(predicate)
+    original = Hive::BoundedProcess.method(:capture3)
+    Hive::BoundedProcess.singleton_class.send(:define_method, :capture3) do |*argv, **kwargs|
       raise Timeout::Error if predicate.call(argv)
 
       original.call(*argv, **kwargs)
     end
     yield
   ensure
-    Open3.singleton_class.send(:define_method, :capture3) do |*argv, **kwargs|
+    Hive::BoundedProcess.singleton_class.send(:define_method, :capture3) do |*argv, **kwargs|
       original.call(*argv, **kwargs)
     end
   end
